## ros-melodic-canopen-402 0.8.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(canopen_402)

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
  set(CMAKE_CXX_STANDARD 14)
endif()

find_package(catkin REQUIRED
  COMPONENTS
    canopen_master
    class_loader
)

find_package(Boost REQUIRED
)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    ${PROJECT_NAME}
  CATKIN_DEPENDS
    canopen_master
  DEPENDS
    Boost
)

include_directories(
  include
  ${Boost_INCLUDE_DIRS}
  ${catkin_INCLUDE_DIRS}
)

# canopen_402
add_library(${PROJECT_NAME}
  src/motor.cpp
)
target_link_libraries(${PROJECT_NAME}
  ${catkin_LIBRARIES}
)

# canopen_402_plugin
add_library(${PROJECT_NAME}_plugin
  src/plugin.cpp
)
target_link_libraries(${PROJECT_NAME}_plugin
   ${catkin_LIBRARIES}
   ${PROJECT_NAME}
)

install(
  TARGETS
    ${PROJECT_NAME}
    ${PROJECT_NAME}_plugin
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)
install(
  FILES
    ${PROJECT_NAME}_plugin.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

if(CATKIN_ENABLE_TESTING)
  catkin_add_gtest(${PROJECT_NAME}-test_clamping
    test/clamping.cpp
  )
  target_link_libraries(${PROJECT_NAME}-test_clamping
    ${catkin_LIBRARIES}
  )
endif()

=== debian/changelog ===
ros-melodic-canopen-402 (0.8.5-1bionic) bionic; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 21 Sep 2020 22:00:00 -0000

ros-melodic-canopen-402 (0.8.4-1bionic) bionic; urgency=high

  * handle illegal states in nextStateForEnabling
  * tranistion -> transition
  * Contributors: Mathias Lüdtke, Mikael Arguedas

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 21 Aug 2020 22:00:00 -0000

ros-melodic-canopen-402 (0.8.3-1bionic) bionic; urgency=high

  * Bump CMake version to avoid CMP0048 warning
    Signed-off-by: ahcorde <mailto:ahcorde@gmail.com>
  * Contributors: ahcorde

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Wed, 06 May 2020 22:00:00 -0000

ros-melodic-canopen-402 (0.8.2-1bionic) bionic; urgency=high

  * enable rosconsole_bridge bindings
  * switch to new logging macros
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 03 Nov 2019 23:00:00 -0000

ros-melodic-canopen-402 (0.8.1-1bionic) bionic; urgency=high

  * Set C++ standard to c++14
  * Contributors: Harsh Deshpande

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sat, 13 Jul 2019 22:00:00 -0000

ros-melodic-canopen-402 (0.8.0-1bionic) bionic; urgency=high

  * handle invalid supported drive modes object
  * made Mode402::registerMode a variadic template
  * use std::isnan
  * migrated to std::atomic
  * migrated to std::unordered_map and std::unordered_set
  * migrated to std pointers
  * fix initialization bug in ProfiledPositionMode
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 10 Jul 2018 22:00:00 -0000

ros-melodic-canopen-402 (0.7.8-1bionic) bionic; urgency=high

  * Revert "pull make_shared into namespaces"
    This reverts commit 9b2cd05df76d223647ca81917d289ca6330cdee6.
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 03 May 2018 22:00:00 -0000

ros-melodic-canopen-402 (0.7.7-1bionic) bionic; urgency=high

  * Added state_switch_timeout parameter to motor.
  * added types for all function objects
  * pull make_shared into namespaces
  * added types for all shared_ptrs
  * migrate to new classloader headers
  * address catkin_lint errors/warnings
  * Contributors: Alexander Gutenkunst, Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 03 May 2018 22:00:00 -0000

ros-melodic-canopen-402 (0.7.6-1bionic) bionic; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 29 Aug 2017 22:00:00 -0000

ros-melodic-canopen-402 (0.7.5-1bionic) bionic; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 28 May 2017 22:00:00 -0000

ros-melodic-canopen-402 (0.7.4-1bionic) bionic; urgency=high

  * use portable boost::math::isnan
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 24 Apr 2017 22:00:00 -0000

ros-melodic-canopen-402 (0.7.3-1bionic) bionic; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 24 Apr 2017 22:00:00 -0000

ros-melodic-canopen-402 (0.7.2-1bionic) bionic; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 27 Mar 2017 22:00:00 -0000

ros-melodic-canopen-402 (0.7.1-1bionic) bionic; urgency=high

  * do quickstop for halt only if operation is enabled
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 19 Mar 2017 23:00:00 -0000

ros-melodic-canopen-402 (0.7.0-1bionic) bionic; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 12 Dec 2016 23:00:00 -0000

ros-melodic-canopen-402 (0.6.5-1bionic) bionic; urgency=high

  * stop on internal limit only if limit was not reached before
  * hardened code with the help of cppcheck
  * Do not send control if it was not changed
    Otherwise invalid state machine transitions might get commanded
  * styled and sorted CMakeLists.txt
    * removed boilerplate comments
    * indention
    * reviewed exported dependencies
  * styled and sorted package.xml
  * update package URLs
  * added option to turn off mode monitor
  * reset Fault_Reset bit in output only
  * enforce rising edge on fault reset bit on init and recover
  * Revert "Enforce rising edge on fault reset bit on init and recover"
  * enforce rising edge on fault reset bit on init and recover
  * Merge pull request #117 <https://github.com/ipa-mdl/ros_canopen/issues/117> from ipa-mdl/condvars
    Reviewed condition variables
  * use boost::numeric_cast for limit checks since it handles 64bit values right
  * add clamping test
  * enforce target type limits
  * ModeTargetHelper is now template
  * readability fix
  * simplified State402::waitForNewState and Motor402::switchState
  * Set Halt bit unless current mode releases it
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 09 Dec 2016 23:00:00 -0000

ros-melodic-canopen-402 (0.6.4-1bionic) bionic; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 02 Jul 2015 22:00:00 -0000

ros-melodic-canopen-402 (0.6.3-1bionic) bionic; urgency=high

  * improved PP mode
  * do not quickstop in fault states
  * do not diable selected mode on recover, just restart it
  * initialize to No_Mode
  * removed some empty lines
  * implemented support for mode switching in a certain 402 state, defaults to Operation_Enable
  * pass LayerStatus to switchMode
  * remove enableMotor, introduced switchState
  * added motor_layer settings
  * fixed PP mode
  * explicit find for class_loader
  * fail-safe setting of op_mode to No_Mode
  * Improved behaviour of concurrent commands
  * added alternative Transitions 7 and 10 via Quickstop
  * added alternative success condition to waitForNewState
  * make motor init/recover interruptable
  * changed maintainer
  * removed SM-based 402 implementation
  * added Motor402 plugin
  * added new 402 implementation
  * added MotorBase


=== debian/control ===
Source: ros-melodic-canopen-402
Section: misc
Priority: optional
Maintainer: Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-canopen-master, ros-melodic-catkin, ros-melodic-class-loader, ros-melodic-rosunit
Homepage: http://wiki.ros.org/canopen_402
Standards-Version: 3.9.2

Package: ros-melodic-canopen-402
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-canopen-master, ros-melodic-class-loader
Description: This implements the CANopen device profile for drives and motion control.
 CiA(r) 402

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-canopen-402//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
